package ic;

import ic.lex.Lexer;
import ic.parser.parser;

import java.io.FileReader;
import java.io.IOException;


/**
 * The main class for the IC Compiler.  The Compiler
 * expects the name of the file to process on the command line,
 * as in:
 * <pre>
 *   java ic.Compiler test.ic
 * </pre>
 * An optional flag <tt>-d<tt> can be provided, as in:
 * <pre>
 *   java ic.Compiler -d test.ic
 * </pre>
 * In this case, messages created by calling {@link ic.Util#debug(String)}
 * or {@link ic.Util#debug(String, Object...)} will be printed to the
 * terminal.  If <tt>-d</tt> is not provided, these messages will
 * be silently ignored.
 */
public class Compiler {

	public static void main(String args[]) throws Exception {

		int n = 0;

		// If first command line argument is -d, turn on debugging
		if (args.length > n && args[n].equals("-d")) {
			Util.debug = true;
			n++;
		}

		// Get name of file
		if (args.length == n) {
			System.out.println("No file given.");			
		} else {
			String file = args[n];

			// example of debug message: This message will only be printed if
			// you provide "-d" on the command line.
			Util.debug("Processing %s...", file);

			// TODO: finish me.  If nothing else, at least add exception handlers
			// for the various types of errors that may occur.
			parser programParser = new parser(new Lexer(new FileReader(file)));
			Object resultValue = (Object)programParser.debug_parse().value;
		}

	}

}

