package ic.error;

/**
 * An exception to indicate a Lexical Error.
 */
public class LexicalError extends Error {
	
	/** The line number where the error occurred. */
	protected int line;
	
	public LexicalError(int line, String message){
		super(message);
		this.line = line + 1;
	}
	
	@Override
	public String getMessage() {
		return "Line " + line + ": " + super.getMessage();
	}
	
	/**
	 * Return the line number of where the error occurred.
	 */
	public int getLine() {
		return line;
	}
}
